Index: squid/src/fs/aufs/store_io_aufs.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/aufs/store_io_aufs.c,v
retrieving revision 1.1.6.6.2.1
retrieving revision 1.1.6.6.2.2
diff -u -r1.1.6.6.2.1 -r1.1.6.6.2.2
--- squid/src/fs/aufs/store_io_aufs.c	22 Apr 2000 20:02:55 -0000	1.1.6.6.2.1
+++ squid/src/fs/aufs/store_io_aufs.c	2 May 2000 22:50:29 -0000	1.1.6.6.2.2
@@ -6,10 +6,6 @@
 #include "squid.h"
 #include "store_asyncufs.h"
 
-#define SWAP_DIR_SHIFT 24
-#define SWAP_FILE_MASK 0x00FFFFFF
-#define MAGIC1 (NUMTHREADS/Config.cacheSwap.n_configured/2)
-
 static AIOCB storeAufsReadDone;
 static AIOCB storeAufsWriteDone;
 static void storeAufsIOCallback(storeIOState * sio, int errflag);
@@ -72,7 +68,6 @@
 storeIOState *
 storeAufsCreate(SwapDir *SD, StoreEntry *e, STFNCB *file_callback, STIOCB *callback, void *callback_data)
 {
-    aioinfo_t *aioinfo = (aioinfo_t *)SD->fsdata;
     char *path ;
     storeIOState *sio;
     sfileno filn;
@@ -80,8 +75,7 @@
 
     /* Allocate a number */
     dirn = SD->index;
-    filn = file_map_allocate(aioinfo->map, aioinfo->suggest);
-    aioinfo->suggest = filn + 1;
+    filn = storeAufsDirMapBitAllocate(SD);
     path = storeAufsDirFullPath(SD, filn, NULL);
 
     debug(78, 3) ("storeAufsCreate: fileno %08X\n", filn);
@@ -108,16 +102,7 @@
     store_open_disk_fd++;
 
     /* now insert into the replacement policy */
-#ifdef HEAP_REPLACEMENT
-    if (EBIT_TEST(e->flags, ENTRY_SPECIAL)) {
-        (void) 0;
-    } else {
-        e->repl.node = heap_insert(SD->repl.heap.heap, e);
-        debug(20, 4) ("storeUfsCreate: inserted node 0x%x\n", e->repl.node);
-    }
-#else
-    dlinkAdd(e, &e->repl.lru, &SD->repl.lru.list);
-#endif
+    storeAufsDirReplAdd(SD, e);
     return sio;
 
 }
@@ -218,18 +203,8 @@
 storeAufsUnlink(SwapDir *SD, StoreEntry *e)
 {
     debug(78, 3) ("storeAufsUnlink: dirno %d, fileno %08X\n", SD->index, e->swap_filen);
+    storeAufsDirReplRemove(e);
     storeAufsDirUnlinkFile(SD, e->swap_filen);
-
-#ifdef HEAP_REPLACEMENT
-    /* And now, release the object from the replacement policy */
-    if (e->repl.node) {
-        debug(20, 4) ("storeUfsUnlink: deleting node 0x%x\n", e->repl.node);
-        heap_delete(SD->repl.heap.heap, e->repl.node);
-        e->repl.node = NULL;
-    }
-#else
-    dlinkDelete(&e->repl.lru, &SD->repl.lru.list);
-#endif
 }
 
 /*  === STATIC =========================================================== */
@@ -312,6 +287,13 @@
     if (cbdataValid(their_data))
 	callback(their_data, aiostate->read_buf, rlen);
     cbdataUnlock(their_data);
+    /* 
+     * XXX is this safe?  The above callback may have caused sio
+     * to be freed/closed already? Philip Guenther <guenther@gac.edu>
+     * says it fixes his FD leaks, with no side effects.
+     */
+    if (aiostate->flags.close_request)
+        storeAufsIOCallback(sio, DISK_OK);
 }
 
 /*
Index: squid/src/fs/coss/store_dir_coss.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/coss/store_dir_coss.c,v
retrieving revision 1.1.4.6
retrieving revision 1.1.4.6.2.1
diff -u -r1.1.4.6 -r1.1.4.6.2.1
--- squid/src/fs/coss/store_dir_coss.c	20 Apr 2000 18:14:23 -0000	1.1.4.6
+++ squid/src/fs/coss/store_dir_coss.c	2 May 2000 22:50:29 -0000	1.1.4.6.2.1
@@ -102,18 +102,28 @@
 storeCossDirSwapLogFile(SwapDir * sd, const char *ext)
 {
     LOCAL_ARRAY(char, path, SQUID_MAXPATHLEN);
+    LOCAL_ARRAY(char, pathtmp, SQUID_MAXPATHLEN);
     LOCAL_ARRAY(char, digit, 32);
+    char *pathtmp2;
     if (Config.Log.swap) {
-	xstrncpy(path, Config.Log.swap, SQUID_MAXPATHLEN - 64);
-	strcat(path, ".");
-	snprintf(digit, 32, "%02d", sd->index);
-	strncat(path, digit, 3);
+        xstrncpy(pathtmp, sd->path, SQUID_MAXPATHLEN - 64);
+        while (index(pathtmp,'/'))
+            *index(pathtmp,'/')='.';
+        while (strlen(pathtmp) && pathtmp[strlen(pathtmp)-1]=='.')
+            pathtmp[strlen(pathtmp)-1]= '\0';
+        for(pathtmp2 = pathtmp; *pathtmp2 == '.'; pathtmp2++);
+        snprintf(path, SQUID_MAXPATHLEN-64, Config.Log.swap, pathtmp2);
+        if (strncmp(path, Config.Log.swap, SQUID_MAXPATHLEN - 64) == 0) {
+            strcat(path, ".");
+            snprintf(digit, 32, "%02d", sd->index);
+            strncat(path, digit, 3);
+        }
     } else {
-	xstrncpy(path, sd->path, SQUID_MAXPATHLEN - 64);
-	strcat(path, "/swap.state");
+        xstrncpy(path, sd->path, SQUID_MAXPATHLEN - 64);
+        strcat(path, "/swap.state");
     }
     if (ext)
-	strncat(path, ext, 16);
+        strncat(path, ext, 16);
     return path;
 }
 
@@ -203,6 +213,7 @@
 		if (e->swap_filen > -1) {
 		    e->swap_filen = -1;
 		}
+                storeRelease(e);
                 /* Fake an unlink here, this is a bad hack :( */
 		dlinkDelete(&e->repl.lru, &rb->sd->repl.lru.list);
 		rb->counts.objcount--;
@@ -320,7 +331,15 @@
 	if (fp != NULL)
 	    fclose(fp);
 	storeCossDirCloseTmpSwapLog(rb->sd);
-	storeRebuildComplete(&rb->counts);
+        /*
+	 * XXX Make sure we don't trigger an assertion if this is the first
+	 * storedir, since if we are, this call will cause storeRebuildComplete
+	 * to prematurely complete the rebuild process, and then some other
+	 * storedir will try to rebuild and eventually die.
+	 */
+        store_dirs_rebuilding++;
+        storeRebuildComplete(&rb->counts);
+        store_dirs_rebuilding--;
 	xfree(rb);
         return;
     }
@@ -612,10 +631,11 @@
 {
   /* Check if the object is a special object, we can't cache these */
   if (EBIT_TEST(e->flags, ENTRY_SPECIAL))
-      return 0;
+      return -1;
 
   /* Otherwise, we're ok */
-  return 1;
+  /* Return 900 (90%) load */
+  return 900;
 }
      
 /* ========== LOCAL FUNCTIONS ABOVE, GLOBAL FUNCTIONS BELOW ========== */
@@ -626,7 +646,6 @@
     CossInfo *cs = (CossInfo *)SD->fsdata;
     
     storeAppendPrintf(sentry, "\n");
-    storeAppendPrintf(sentry, "Store Directory #%d: %s\n", SD->index, SD->path);
     storeAppendPrintf(sentry, "Maximum Size: %d KB\n", SD->max_size);
     storeAppendPrintf(sentry, "Current Size: %d KB\n", SD->cur_size);
     storeAppendPrintf(sentry, "Percent Used: %0.2f%%\n",
@@ -686,6 +705,8 @@
     sd->checkobj = storeCossDirCheckObj;
     sd->refobj = NULL;			/* LRU is done in storeCossRead */
     sd->unrefobj = NULL;
+    sd->callback = NULL;
+    sd->sync = NULL; /* should we make it call the coss sync? */
 
     sd->obj.create = storeCossCreate;
     sd->obj.open = storeCossOpen;
@@ -818,8 +839,6 @@
     storefs->parsefunc = storeCossDirParse;
     storefs->reconfigurefunc = storeCossDirReconfigure;
     storefs->donefunc = storeCossDirDone;
-    storefs->callbackfunc = NULL;
-    storefs->syncfunc = NULL; /* should we make it call the coss sync? */
     coss_membuf_pool = memPoolCreate("COSS Membuf data", sizeof(CossMemBuf));
     coss_state_pool = memPoolCreate("COSS IO State data", sizeof(CossState));
     coss_initialised = 1;
Index: squid/src/fs/coss/store_io_coss.c
===================================================================
RCS file: /cvsroot/squid-sf//squid/src/fs/coss/store_io_coss.c,v
retrieving revision 1.1.4.8.2.2
retrieving revision 1.1.4.8.2.3
diff -u -r1.1.4.8.2.2 -r1.1.4.8.2.3
--- squid/src/fs/coss/store_io_coss.c	22 Apr 2000 20:02:55 -0000	1.1.4.8.2.2
+++ squid/src/fs/coss/store_io_coss.c	2 May 2000 22:50:29 -0000	1.1.4.8.2.3
@@ -139,7 +139,7 @@
     sio->st_size = objectLen(e) + e->mem_obj->swap_hdr_sz;
     sio->swap_dirn = SD->index;
     sio->swap_filen = storeCossAllocate(SD, e, COSS_ALLOC_ALLOCATE);
-    debug(81, 3) ("storeCossCreate: offset %d\n", sio->swap_filen);
+    debug(81, 3) ("storeCossCreate: offset %d, size %d, end %d\n", sio->swap_filen, sio->st_size, sio->swap_filen + sio->st_size);
 
     sio->callback = callback;
     sio->callback_data = callback_data;
--- /dev/null	Wed Feb 14 00:43:41 2007
+++ squid/src/fs/diskd/diskd.c	Wed Feb 14 00:43:55 2007
@@ -0,0 +1,310 @@
+
+#include "config.h"
+#include "squid.h"
+
+
+#include "store_diskd.h"
+
+#include <sys/ipc.h>
+#include <sys/msg.h>
+#include <sys/shm.h>
+
+#undef assert
+#include <assert.h>
+
+
+#define STDERR_DEBUG 0
+
+typedef struct _file_state file_state;
+
+struct _file_state {
+    void *key;
+    file_state *next;
+    int id;
+    int fd;
+    off_t offset;
+};
+
+static hash_table *hash = NULL;
+static pid_t mypid;
+static char *shmbuf;
+
+static int
+do_open(diomsg * r, int len, const char *buf)
+{
+    int fd;
+    file_state *fs;
+    /*
+     * note r->offset holds open() flags
+     */
+    fd = open(buf, r->offset, 0600);
+    if (fd < 0) {
+	fprintf(stderr, "%d %s: ", (int) mypid, buf);
+	perror("open");
+	return -errno;
+    }
+    fs = xcalloc(1, sizeof(*fs));
+    fs->id = r->id;
+    fs->key = &fs->id;		/* gack */
+    fs->fd = fd;
+    hash_join(hash, (hash_link *) fs);
+#if STDERR_DEBUG
+    fprintf(stderr, "%d OPEN  id %d, FD %d, fs %p\n",
+	(int) mypid,
+	fs->id,
+	fs->fd,
+	fs);
+#endif
+    return fd;
+}
+
+static int
+do_close(diomsg * r, int len)
+{
+    int fd;
+    file_state *fs;
+    fs = (file_state *) hash_lookup(hash, &r->id);
+    if (NULL == fs) {
+	errno = EBADF;
+	fprintf(stderr, "%d CLOSE id %d: ", (int) mypid, r->id);
+	perror("do_close");
+	return -EBADF;
+    }
+    fd = fs->fd;
+    hash_remove_link(hash, (hash_link *) fs);
+#if STDERR_DEBUG
+    fprintf(stderr, "%d CLOSE id %d, FD %d, fs %p\n",
+	(int) mypid,
+	r->id,
+	fs->fd,
+	fs);
+#endif
+    xfree(fs);
+    return close(fd);
+}
+
+static int
+do_read(diomsg * r, int len, char *buf)
+{
+    int x;
+    int readlen = r->size;
+    file_state *fs;
+    fs = (file_state *) hash_lookup(hash, &r->id);
+    if (NULL == fs) {
+	errno = EBADF;
+	fprintf(stderr, "%d READ  id %d: ", (int) mypid, r->id);
+	perror("do_read");
+	return -EBADF;
+    }
+    if (r->offset > -1 && r->offset != fs->offset) {
+#if STDERR_DEBUG
+	fprintf(stderr, "seeking to %d\n", r->offset);
+#endif
+	if (lseek(fs->fd, r->offset, SEEK_SET) < 0) {
+	    fprintf(stderr, "%d FD %d, offset %d: ", (int) mypid, fs->fd, r->offset);
+	    perror("lseek");
+	}
+    }
+    x = read(fs->fd, buf, readlen);
+#if STDERR_DEBUG
+    fprintf(stderr, "%d READ %d,%d,%d ret %d\n", (int) mypid,
+	fs->fd, readlen, r->offset, x);
+#endif
+    if (x < 0) {
+	fprintf(stderr, "%d FD %d: ", (int) mypid, fs->fd);
+	perror("read");
+	return -errno;
+    }
+    fs->offset = r->offset + x;
+    return x;
+}
+
+static int
+do_write(diomsg * r, int len, const char *buf)
+{
+    int wrtlen = r->size;
+    int x;
+    file_state *fs;
+    fs = (file_state *) hash_lookup(hash, &r->id);
+    if (NULL == fs) {
+	errno = EBADF;
+	fprintf(stderr, "%d WRITE id %d: ", (int) mypid, r->id);
+	perror("do_write");
+	return -EBADF;
+    }
+    if (r->offset > -1 && r->offset != fs->offset) {
+	if (lseek(fs->fd, r->offset, SEEK_SET) < 0) {
+	    fprintf(stderr, "%d FD %d, offset %d: ", (int) mypid, fs->fd, r->offset);
+	    perror("lseek");
+	}
+    }
+#if STDERR_DEBUG
+    fprintf(stderr, "%d WRITE %d,%d,%d\n", (int) mypid,
+	fs->fd, wrtlen, r->offset);
+#endif
+    x = write(fs->fd, buf, wrtlen);
+    if (x < 0) {
+	fprintf(stderr, "%d FD %d: ", (int) mypid, fs->fd);
+	perror("write");
+	return -errno;
+    }
+    fs->offset = r->offset + x;
+    return x;
+}
+
+static int
+do_unlink(diomsg * r, int len, const char *buf)
+{
+    if (truncate(buf, 0) < 0) {
+	fprintf(stderr, "%d UNLNK id %d %s: ", (int) mypid, r->id, buf);
+	perror("truncate");
+	return -errno;
+    }
+#if STDERR_DEBUG
+    fprintf(stderr, "%d UNLNK %s\n", (int) mypid, buf);
+#endif
+    return 0;
+}
+
+static void
+msg_handle(diomsg * r, int rl, diomsg * s)
+{
+    char *buf = NULL;
+    s->mtype = r->mtype;
+    s->callback_data = r->callback_data;
+    s->shm_offset = r->shm_offset;
+    s->id = r->id;
+    if (s->shm_offset > -1)
+	buf = shmbuf + s->shm_offset;
+    switch (r->mtype) {
+    case _MQD_OPEN:
+	s->status = do_open(r, rl, buf);
+	break;
+    case _MQD_CLOSE:
+	s->status = do_close(r, rl);
+	break;
+    case _MQD_READ:
+	s->status = do_read(r, rl, buf);
+	break;
+    case _MQD_WRITE:
+	s->status = do_write(r, rl, buf);
+	break;
+    case _MQD_UNLINK:
+	s->status = do_unlink(r, rl, buf);
+	break;
+    default:
+	assert(0);
+	break;
+    }
+}
+
+int
+fsCmp(const void *a, const void *b)
+{
+    const int *A = a;
+    const int *B = b;
+    return *A != *B;
+}
+
+unsigned int
+fsHash(const void *key, unsigned int n)
+{
+    /* note, n must be a power of 2! */
+    const int *k = key;
+    return (*k & (--n));
+}
+
+static void
+alarm_handler(int sig)
+{
+    (void) 0;
+}
+
+int
+main(int argc, char *argv[])
+{
+    int key;
+    int rmsgid;
+    int smsgid;
+    int shmid;
+    diomsg rmsg;
+    diomsg smsg;
+    int rlen;
+    char rbuf[512];
+    struct sigaction sa;
+    setbuf(stdout, NULL);
+    setbuf(stderr, NULL);
+    mypid = getpid();
+    assert(4 == argc);
+    key = atoi(argv[1]);
+    rmsgid = msgget(key, 0600);
+    if (rmsgid < 0) {
+	perror("msgget");
+	return 1;
+    }
+    key = atoi(argv[2]);
+    smsgid = msgget(key, 0600);
+    if (smsgid < 0) {
+	perror("msgget");
+	return 1;
+    }
+    key = atoi(argv[3]);
+    shmid = shmget(key, 0, 0600);
+    if (shmid < 0) {
+	perror("shmget");
+	return 1;
+    }
+    shmbuf = shmat(shmid, NULL, 0);
+    if (shmbuf == (void *) -1) {
+	perror("shmat");
+	return 1;
+    }
+    hash = hash_create(fsCmp, 1 << 4, fsHash);
+    assert(hash);
+    fcntl(0, F_SETFL, SQUID_NONBLOCK);
+    memset(&sa, '\0', sizeof(sa));
+    sa.sa_handler = alarm_handler;
+    sa.sa_flags = SA_RESTART;
+    sigaction(SIGALRM, &sa, NULL);
+    for (;;) {
+	alarm(1);
+	memset(&rmsg, '\0', sizeof(rmsg));
+	rlen = msgrcv(rmsgid, &rmsg, msg_snd_rcv_sz, 0, 0);
+	if (rlen < 0) {
+	    if (EINTR == errno) {
+		if (read(0, rbuf, 512) <= 0) {
+		    if (EWOULDBLOCK == errno)
+			(void) 0;
+		    else if (EAGAIN == errno)
+			(void) 0;
+		    else
+			break;
+		}
+	    }
+	    if (EAGAIN == errno) {
+		continue;
+	    }
+	    perror("msgrcv");
+	    break;
+	}
+	alarm(0);
+	msg_handle(&rmsg, rlen, &smsg);
+	if (msgsnd(smsgid, &smsg, msg_snd_rcv_sz, 0) < 0) {
+	    perror("msgsnd");
+	    break;
+	}
+    }
+#if STDERR_DEBUG
+    fprintf(stderr, "%d diskd exiting\n", (int) mypid);
+#endif
+    if (msgctl(rmsgid, IPC_RMID, 0) < 0)
+	perror("msgctl IPC_RMID");
+    if (msgctl(smsgid, IPC_RMID, 0) < 0)
+	perror("msgctl IPC_RMID");
+    if (shmdt(shmbuf) < 0)
+	perror("shmdt");
+    if (shmctl(shmid, IPC_RMID, 0) < 0)
+	perror("shmctl IPC_RMID");
+    return 0;
+}
+
